////////////////////////////////////////
// ļ: main.c
// ļ: 
// ļ汾: V1.0
// ޸ļ¼:
//   1. (2025-04-26) ļ
////////////////////////////////////////

//#include "config.h"                     //ĬѰstdio.hintrins.hai_usb.hͷļ
#define HIRC                    24000000UL
#define FOSC                    24000000UL
#define SYSCLK                  FOSC
#define MAIN_Fosc               FOSC

#define PRINTF_USB                      //printfضUSB

#include <ai8051u.h>
#include <stdio.h>
#include <intrins.h>

#include "def.h"
#include "ai8051u_def.h"
#include "ai_usb.h"

void CLK_Init(void);
void TIMER0_Init(void);
void TIMER1_Init(void);
void USBLIB_Init(void);
void USBLIB_WaitConfiged(void);
void USBLIB_OUT_Done(void);
void PORT3_Init(void);


void SYS_Init(void);
void delay_ms(uint16_t ms);

volatile uint16_t time_100us = 0;      // 100sʱ
volatile uint8_t pulse_count = 0;      // 0~63
volatile uint16_t pulse_widths[64];    // 洢ߵ͵ƽʱ
volatile bit last_state = 0;           // ʼ״̬Ϊߵƽ
volatile bit capturing = 0;            // ־λ

////////////////////////////////////////
// Ŀ
// ڲ: 
// : 
////////////////////////////////////////
void main(void)
{
	u8 i;
    SYS_Init();
	
    while (1)
    {
			if (pulse_count >= 50) {       // NEC֡35أ
            printf("Timing (x10us):\n");
            for ( i = 0; i < pulse_count; i++) {
                printf("%d ", pulse_widths[i]);
            }
            printf("\n");
            
            pulse_count = 0;           // ׼һβ
        }
			
        USBLIB_OUT_Done();              //ѯʽUSBյ
    }
}

////////////////////////////////////////
// ϵͳʼ
// ڲ: 
// : 
////////////////////////////////////////
void SYS_Init(void)
{
    EnableAccessXFR();                  //ʹܷչXFR
    AccessCodeFastest();                //ٶȷʳ
    AccessIXramFastest();               //ٶȷڲXDATA
    IAP_SetTimeBase();                  //IAPȴ,1usʱ

    P0M0 = 0x00; P0M1 = 0x00;           //ʼP0Ϊ׼˫ģʽ
    P1M0 = 0x00; P1M1 = 0x00;           //ʼP1Ϊ׼˫ģʽ
    P2M0 = 0x00; P2M1 = 0x00;           //ʼP2Ϊ׼˫ģʽ
    P3M0 = 0x00; P3M1 = 0x00;           //ʼP3Ϊ׼˫ģʽ
    P4M0 = 0x00; P4M1 = 0x00;           //ʼP4Ϊ׼˫ģʽ
    P5M0 = 0x00; P5M1 = 0x00;           //ʼP5Ϊ׼˫ģʽ
    P6M0 = 0x00; P6M1 = 0x00;           //ʼP6Ϊ׼˫ģʽ
    P7M0 = 0x00; P7M1 = 0x00;           //ʼP7Ϊ׼˫ģʽ

    CLK_Init();                         //ʱģʼ
    TIMER0_Init();                      //ʱ0ʼ
    TIMER1_Init();                      //ʱ1ʼ
	PORT3_Init();                       //P35½ش
    USBLIB_Init();                      //USBʼ

    EnableGlobalInt();                  //ʹȫж
}

////////////////////////////////////////
// ʱ
// ڲ: ms (ʱĺֵ)
// : 
////////////////////////////////////////
void delay_ms(uint16_t ms)
{
    uint16_t i;

    do
    {
        i = MAIN_Fosc / 6000;
        while (--i);
    } while (--ms);
}

////////////////////////////////////////
// ʱ0жϷ
// ڲ: 
// : 
////////////////////////////////////////
void TIMER0_ISR(void) interrupt TMR0_VECTOR
{
}

bit time_start;
u8 IR_State=0;
u16 IR_Time=0;
void TIMER1_ISR(void) interrupt TMR1_VECTOR
{		

		time_100us++;                      // ÿ100us
    if (time_100us > 2000) {           // ʱã200ms
        time_100us = 0;
        pulse_count = 0;
        capturing = 0;
		//EnableP3nInt(0x20);                 //ʹP3.5ж
        TIMER1_Stop();
    }
}
////////////////////////////////////////
// ˿3жϷ
// ڲ: 
// : 
////////////////////////////////////////

volatile bit first_capture = 0;
void PORT3_ISR(void) interrupt P3INT_VECTOR
{
	ClearP3nFlag(BIT_ALL);             // жϱ־	
	    // л״̬⣨ؼ
	last_state = !last_state;      // ״̬ת
		if (last_state) {
			SetP3nRisingInt(0x20);     // ´μ
		} else {
			SetP3nFallingInt(0x20);    // ´μ½
		}		
	    
    if (!capturing) {
        // ״½أʼ
        time_100us = 0;
        capturing = 1;
		time_100us=0;
		
        TIMER1_Run();		
    } else {
        // ¼ǰƽʱ
        if (pulse_count < 64) {
            pulse_widths[pulse_count++] = time_100us;			
            time_100us = 0;			
        }
        
    
        
    }
}




////////////////////////////////////////
// ʱӳʼ
// ڲ: 
// : 
////////////////////////////////////////
void CLK_Init(void)
{
    CLK_SYSCLK_Divider(10);             //лʱǰȽϵͳʱӽƵ

    HIRC_24M();                         //ѡڲԤõƵ

    CLK_MCLK_HIRC();                    //ѡڲ߾HIRCΪʱ
    CLK_MCLK2_BYPASS();                 //·MCLK2,ֱʹMCLKѡ

    CLK_SYSCLK_Divider(1);              //ϵͳʱӷƵϵ

    CLK_HSIOCK_MCLK();                  //ѡMCLKʱΪʱԴ
    CLK_HSIOCK_Divider(1);              //øʱԤƵϵ

    CLK_SPICLK_Divider(1);              //SPIʱԤƵϵ
    CLK_I2SCLK_Divider(1);              //I2SʱԤƵϵ
    CLK_PWMACLK_Divider(1);             //PWMAʱԤƵϵ
    CLK_PWMBCLK_Divider(1);             //PWMBʱԤƵϵ
    CLK_TFPUCLK_Divider(1);             //TFPUʱԤƵϵ
}

////////////////////////////////////////
// ʱ0ʼ
// ڲ: 
// : 
////////////////////////////////////////
void TIMER0_Init(void)
{
#define T0_PSCR         0
#define T0_RELOAD       (65536 - (float)SYSCLK / 12 / (T0_PSCR + 1) * 1 / 1000)

    TIMER0_TimerMode();                 //öʱ0Ϊʱģʽ
    TIMER0_12TMode();                   //öʱ0Ϊ12Tģʽ
    TIMER0_Mode0();                     //öʱ0Ϊģʽ0 (16λԶģʽ)
    TIMER0_DisableGateINT0();           //ֹʱ0ſ
    TIMER0_SetIntPriority(0);           //жΪȼ
    TIMER0_EnableInt();                 //ʹܶʱ0ж
    TIMER0_SetPrescale(T0_PSCR);        //öʱ08λԤƵ
    TIMER0_SetReload16(T0_RELOAD);      //öʱ016λֵ
    TIMER0_Run();                       //ʱ0ʼ
}

////////////////////////////////////////
// ʱ1ʼ
// ڲ: 
// : 
////////////////////////////////////////
void TIMER1_Init(void)
{
#define T1_PSCR         0
#define T1_RELOAD       (65536 - (float)SYSCLK / 12 / (T1_PSCR + 1) * 1 / 100000)

    TIMER1_TimerMode();                 //öʱ1Ϊʱģʽ
    TIMER1_12TMode();                   //öʱ1Ϊ12Tģʽ
    TIMER1_Mode0();                     //öʱ1Ϊģʽ0 (16λԶģʽ)
    TIMER1_DisableGateINT1();           //ֹʱ1ſ
    TIMER1_SetIntPriority(0);           //жΪȼ
    TIMER1_EnableInt();                 //ʹܶʱ1ж
    TIMER1_SetPrescale(T1_PSCR);        //öʱ18λԤƵ
    TIMER1_SetReload16(T1_RELOAD);      //öʱ116λֵ
    TIMER1_Run();                       //ʱ1ʼ
}



////////////////////////////////////////
// P3ڳʼ
// ڲ: 
// : 
////////////////////////////////////////
void PORT3_Init(void)
{
    SetP3nQuasiMode(BIT_ALL);           //P3Ϊ׼˫ģʽ

    DisableP3nPullUp(BIT_ALL);          //رP3ڲ
    DisableP3nPullDown(BIT_ALL);        //رP3ڲ
    DisableP3nSchmitt(BIT_ALL);         //ʹP3ʩش
    SetP3nSlewRateNormal(BIT_ALL);      //P3һ㷭תٶ
    SetP3nDrivingNormal(BIT_ALL);       //P3һ
    SetP3nDigitalInput(BIT_ALL);        //ʹP3ź빦

    SetP3nFallingInt(0x20);             //P3.5Ϊ½ж

	

    EnableP3nInt(0x20);                 //ʹP3.5ж
	

    SetP3IntPriority(3);                //жΪȼ
}






////////////////////////////////////////
// USBʼ
// ڲ: 
// : 
////////////////////////////////////////
void USBLIB_Init(void)
{
    usb_init();                         //ʼUSBģ
    USB_SetIntPriority(0);              //жΪȼ
    set_usb_ispcmd("@STCISP#");         //USBͣ
}

////////////////////////////////////////
// ȴUSBɺ
// ڲ: 
// : 
////////////////////////////////////////
void USBLIB_WaitConfiged(void)
{
    while (DeviceState != DEVSTATE_CONFIGURED); //ȴUSB
}

////////////////////////////////////////
// USB豸ݴ
// ڲ: 
// : 
// bUsbOutReadyUSB豸ݱ־λ
// OutNumberUSB豸յݳ
// UsbOutBufferUSB豸յ
////////////////////////////////////////
void USBLIB_OUT_Done(void)
{
    if (bUsbOutReady)                   //ѯǷнյ
    {
        USB_SendData(UsbOutBuffer, OutNumber); //ԭ·, ڲ
        usb_OUT_done();                 //ǰݴ
    }
}


